Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/CoolEmAllStringSerializer.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/CoolEmAllStringSerializer.java	(revision 1140)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/CoolEmAllStringSerializer.java	(revision 1207)
@@ -1,4 +1,5 @@
 package simulator.stats.implementation.out;
 
+import java.text.DecimalFormat;
 import java.util.Map;
 
@@ -7,9 +8,14 @@
 
 import schedframe.resources.CoolEmAllResourceType;
+import schedframe.resources.ResourceHistoryChanges;
 import schedframe.resources.StandardResourceType;
+import simulator.stats.implementation.MetricsStats;
 import simulator.stats.implementation.ResourceAirFlowStats;
+import simulator.stats.implementation.ResourceAvailabilityStats;
+import simulator.stats.implementation.ResourceHistoryStats;
 import simulator.stats.implementation.ResourcePowerStats;
 import simulator.stats.implementation.ResourceTemperatureStats;
 import simulator.stats.implementation.ResourceUsageStats;
+import simulator.stats.implementation.ResourceUsefulWorkStats;
 
 public class CoolEmAllStringSerializer extends StringSerializer {
@@ -19,5 +25,6 @@
 	public Object visit(ResourceUsageStats resourceUsageStats) {
 		Map<Long, Double> resourceUsage = resourceUsageStats.getHistory();
-		String cpuMetricName = "CPU_Load";
+		//String metricName = "cpu_load";
+		String metricName = resourceUsageStats.getUsageType();
 		int mapSize = resourceUsage.size();
 		/*
@@ -45,10 +52,12 @@
 		}
 		
-		if(resourceUsageStats.getResourceType().equals(StandardResourceType.Processor) || resourceUsageStats.getResourceType().equals(CoolEmAllResourceType.Processor)){
+		if(!resourceUsageStats.getResourceType().getName().equals(StandardResourceType.Core.getName()) && !resourceUsageStats.getResourceType().getName().equals(CoolEmAllResourceType.Core.getName())){
 			for (Long timestamp : resourceUsage.keySet()) {
 				
-				buffer.append(cpuMetricName);
-				buffer.append(fieldSeparator);
-				buffer.append(resourceUsageStats.getResourceName());
+				buffer.append(metricName);
+				buffer.append(fieldSeparator);
+				if(resourceUsageStats.getResourceName().startsWith("/"))
+					buffer.append(resourceUsageStats.getResourceName().substring(1));
+				else buffer.append(resourceUsageStats.getResourceName());
 				buffer.append(fieldSeparator);
 				Double value = resourceUsage.get(timestamp);
@@ -73,5 +82,6 @@
 	public Object visit(ResourcePowerStats resourceEnergyStats) {
 		Map<Long, Double> resourceEnergy = resourceEnergyStats.getHistory();
-		String nodeMetricName = "RECS_Power";
+		//String nodeMetricName = "power";
+		String metricName = resourceEnergyStats.getUsageType();
 		int mapSize = resourceEnergy.size();
 		/*
@@ -98,9 +108,11 @@
 			buffer = new StringBuffer(size);
 		}
-		
-		if(resourceEnergyStats.getResourceType().equals(StandardResourceType.ComputingNode) || resourceEnergyStats.getResourceType().equals(CoolEmAllResourceType.Node)){
+		//if(resourceEnergyStats.getResourceType().getName().equals(StandardResourceType.ComputingNode.getName()) || resourceEnergyStats.getResourceType().getName().equals(CoolEmAllResourceType.Node.getName()) || 
+				//resourceEnergyStats.getResourceType().getName().equals(StandardResourceType.Inlet.getName())  || resourceEnergyStats.getResourceType().getName().equals(StandardResourceType.Outlet.getName()) || 
+		//		resourceEnergyStats.getResourceType().getName().equals(StandardResourceType.Heatsink.getName())){
+		
 			for (Long timestamp : resourceEnergy.keySet()) {
 				
-				buffer.append(nodeMetricName);
+				buffer.append(metricName);
 				buffer.append(fieldSeparator);
 				if(resourceEnergyStats.getResourceName().startsWith("/"))
@@ -117,5 +129,5 @@
 				buffer.append(System.getProperty("line.separator"));
 			}
-		}
+	//	}
 
 		int lastIdx = buffer.lastIndexOf(System.getProperty("line.separator"));
@@ -129,5 +141,6 @@
 	public Object visit(ResourceAirFlowStats resourceAirFlowStats) {
 		Map<Long, Double> resourceAirFlow = resourceAirFlowStats.getHistory();
-		String nodeMetricName = "RECS_Airflow";
+		//String nodeMetricName = "airflow_volume";
+		String metricName = resourceAirFlowStats.getUsageType();
 		int mapSize = resourceAirFlow.size();
 		/*
@@ -154,9 +167,8 @@
 			buffer = new StringBuffer(size);
 		}
-		
-		if(resourceAirFlowStats.getResourceType().equals(StandardResourceType.ComputingNode) || resourceAirFlowStats.getResourceType().equals(CoolEmAllResourceType.Node)){
+
+		if(resourceAirFlowStats.getResourceType().getName().equals(StandardResourceType.Inlet.getName()) || resourceAirFlowStats.getResourceType().getName().equals(StandardResourceType.Outlet.getName())){
 			for (Long timestamp : resourceAirFlow.keySet()) {
-				
-				buffer.append(nodeMetricName);
+				buffer.append(metricName);
 				buffer.append(fieldSeparator);
 				if(resourceAirFlowStats.getResourceName().startsWith("/"))
@@ -185,6 +197,9 @@
 	public Object visit(ResourceTemperatureStats resourceTemperatureStats) {
 		Map<Long, Double> resourceTemperature = resourceTemperatureStats.getHistory();
-		String nodeMetricName = "RECS_Temperature";
-		String cpuMetricName = "CPU_Temp";
+		//String nodeMetricName = "temperature";
+		//String cpuMetricName = "temperature";
+		
+		String metricName = resourceTemperatureStats.getUsageType();
+
 		int mapSize = resourceTemperature.size();
 		/*
@@ -212,17 +227,18 @@
 		}
 		
-		if(resourceTemperatureStats.getResourceType().equals(StandardResourceType.ComputingNode) || resourceTemperatureStats.getResourceType().equals(CoolEmAllResourceType.Node) || 
-				resourceTemperatureStats.getResourceType().equals(StandardResourceType.Processor) || resourceTemperatureStats.getResourceType().equals(CoolEmAllResourceType.Processor)){
-			String metricName = null;
+		if(resourceTemperatureStats.getResourceType().getName().equals(StandardResourceType.Node.getName()) || resourceTemperatureStats.getResourceType().getName().equals(StandardResourceType.Processor.getName())){
+			/*String metricName = null;
 			if(resourceTemperatureStats.getResourceType().equals(StandardResourceType.ComputingNode) || resourceTemperatureStats.getResourceType().equals(CoolEmAllResourceType.Node)){
 				metricName = nodeMetricName;
 			} else if(resourceTemperatureStats.getResourceType().equals(StandardResourceType.Processor) || resourceTemperatureStats.getResourceType().equals(CoolEmAllResourceType.Processor)){
 				metricName = cpuMetricName;
-			}
+			}*/
 			for (Long timestamp : resourceTemperature.keySet()) {
 				
 				buffer.append(metricName);
 				buffer.append(fieldSeparator);
-				buffer.append(resourceTemperatureStats.getResourceName());
+				if(resourceTemperatureStats.getResourceName().startsWith("/"))
+					buffer.append(resourceTemperatureStats.getResourceName().substring(1));
+				else buffer.append(resourceTemperatureStats.getResourceName());
 				buffer.append(fieldSeparator);
 				Double value = resourceTemperature.get(timestamp);
@@ -245,4 +261,140 @@
 	}
 
-
+	public Object visit(MetricsStats metricsStats) {
+		StringBuffer buffer = null;
+
+		if(printedHeaders.add("metrics")) {
+			buffer = new StringBuffer(600);
+			/*String[] headers = metricsStats.getHeaders();
+			for(int i = 0; i < headers.length; i++)
+			{
+				buffer.append(headers[i]);
+				buffer.append(fieldSeparator);
+			}
+			buffer.append(System.getProperty("line.separator"));*/
+		} else {
+			buffer = new StringBuffer(300);
+		}
+		DecimalFormat df = new DecimalFormat();
+		df.setMaximumFractionDigits(3);
+		df.setGroupingUsed(false);
+		
+		buffer.append(metricsStats.getMetricName());
+		buffer.append(fieldSeparator);
+		buffer.append(metricsStats.getResourceName());
+		buffer.append(fieldSeparator);
+		buffer.append(metricsStats.getTimestamp());
+		buffer.append(fieldSeparator);
+		buffer.append(df.format(metricsStats.getValue()));
+		buffer.append(fieldSeparator);
+
+		return buffer.toString();
+	}
+	
+	public Object visit(ResourceHistoryStats arg) {
+		StringBuffer buffer = null;
+
+		if(printedHeaders.add("metrics")) {
+			buffer = new StringBuffer(600);
+			/*String[] headers = metricsStats.getHeaders();
+			for(int i = 0; i < headers.length; i++)
+			{
+				buffer.append(headers[i]);
+				buffer.append(fieldSeparator);
+			}
+			buffer.append(System.getProperty("line.separator"));*/
+		} else {
+			buffer = new StringBuffer(300);
+		}
+		DecimalFormat df = new DecimalFormat();
+		df.setMaximumFractionDigits(3);
+		df.setGroupingUsed(false);
+		
+		for(ResourceHistoryChanges rhc: arg.getResHistChanges()){
+			buffer.append(rhc.getTimestamp());
+			buffer.append(fieldSeparator);
+			buffer.append(rhc.getResourceName());
+			buffer.append(fieldSeparator);
+			buffer.append(rhc.getOperation());
+			buffer.append(fieldSeparator);
+			buffer.append(rhc.getParamter());
+			buffer.append(fieldSeparator);
+			buffer.append(System.getProperty("line.separator"));
+		}
+
+		return buffer.toString();
+	}
+
+	public Object visit(ResourceUsefulWorkStats resourceUsefulWorkStats) {
+			
+		String metricName = resourceUsefulWorkStats.getUsageType();
+		
+		StringBuffer buffer = null;
+
+		if(printedHeaders.add("metrics")) {
+			buffer = new StringBuffer(600);
+			/*String[] headers = metricsStats.getHeaders();
+			for(int i = 0; i < headers.length; i++)
+			{
+				buffer.append(headers[i]);
+				buffer.append(fieldSeparator);
+			}
+			buffer.append(System.getProperty("line.separator"));*/
+		} else {
+			buffer = new StringBuffer(300);
+		}
+		DecimalFormat df = new DecimalFormat();
+		df.setMaximumFractionDigits(3);
+		df.setGroupingUsed(false);
+		if(!resourceUsefulWorkStats.getResourceType().getName().equals(StandardResourceType.Core.getName()) && !resourceUsefulWorkStats.getResourceType().getName().equals(CoolEmAllResourceType.Core.getName())){
+
+			buffer.append(metricName);
+			buffer.append(fieldSeparator);
+			buffer.append(resourceUsefulWorkStats.getResourceName());
+			buffer.append(fieldSeparator);
+			buffer.append(resourceUsefulWorkStats.getTimestamp());
+			buffer.append(fieldSeparator);
+			buffer.append(df.format(resourceUsefulWorkStats.getValue()));
+			buffer.append(fieldSeparator);
+			buffer.append(System.getProperty("line.separator"));
+		}
+		return buffer.toString();
+	}
+	
+
+	public Object visit(ResourceAvailabilityStats resourceAvailabilityStats) {
+		
+		String metricName = resourceAvailabilityStats.getUsageType();
+		
+		StringBuffer buffer = null;
+
+		if(printedHeaders.add("metrics")) {
+			buffer = new StringBuffer(600);
+			/*String[] headers = metricsStats.getHeaders();
+			for(int i = 0; i < headers.length; i++)
+			{
+				buffer.append(headers[i]);
+				buffer.append(fieldSeparator);
+			}
+			buffer.append(System.getProperty("line.separator"));*/
+		} else {
+			buffer = new StringBuffer(300);
+		}
+		DecimalFormat df = new DecimalFormat();
+		df.setMaximumFractionDigits(3);
+		df.setGroupingUsed(false);
+		if(resourceAvailabilityStats.getResourceType().getName().equals(CoolEmAllResourceType.NodeGroup.getName())){
+
+			buffer.append(metricName);
+			buffer.append(fieldSeparator);
+			buffer.append(resourceAvailabilityStats.getResourceName());
+			buffer.append(fieldSeparator);
+			buffer.append(resourceAvailabilityStats.getTimestamp());
+			buffer.append(fieldSeparator);
+			buffer.append(df.format(resourceAvailabilityStats.getValue()));
+			buffer.append(fieldSeparator);
+			buffer.append(System.getProperty("line.separator"));
+		}
+		return buffer.toString();
+	}
 }
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/StatsSerializer.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/StatsSerializer.java	(revision 805)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/StatsSerializer.java	(revision 1207)
@@ -4,9 +4,13 @@
 import simulator.stats.implementation.GSSAccumulatorsStats;
 import simulator.stats.implementation.JobStats;
+import simulator.stats.implementation.MetricsStats;
 import simulator.stats.implementation.ResourceAirFlowStats;
+import simulator.stats.implementation.ResourceAvailabilityStats;
+import simulator.stats.implementation.ResourceHistoryStats;
 import simulator.stats.implementation.ResourcePowerStats;
 import simulator.stats.implementation.ResourceStats;
 import simulator.stats.implementation.ResourceTemperatureStats;
 import simulator.stats.implementation.ResourceUsageStats;
+import simulator.stats.implementation.ResourceUsefulWorkStats;
 import simulator.stats.implementation.TaskStats;
 
@@ -34,5 +38,13 @@
 	public Object visit(ResourceTemperatureStats arg);
 	
+	public Object visit(ResourceUsefulWorkStats arg);
+	
 	public Object visit(GSSAccumulatorsStats arg);
 	
+	public Object visit(MetricsStats arg);
+	
+	public Object visit(ResourceHistoryStats arg);
+
+	public Object visit(ResourceAvailabilityStats resourceAvailabilityStats);
+	
 }
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/StringSerializer.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/StringSerializer.java	(revision 1192)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/out/StringSerializer.java	(revision 1207)
@@ -11,9 +11,13 @@
 import simulator.stats.implementation.GSSAccumulatorsStats;
 import simulator.stats.implementation.JobStats;
+import simulator.stats.implementation.MetricsStats;
 import simulator.stats.implementation.ResourceAirFlowStats;
+import simulator.stats.implementation.ResourceAvailabilityStats;
+import simulator.stats.implementation.ResourceHistoryStats;
 import simulator.stats.implementation.ResourcePowerStats;
 import simulator.stats.implementation.ResourceStats;
 import simulator.stats.implementation.ResourceTemperatureStats;
 import simulator.stats.implementation.ResourceUsageStats;
+import simulator.stats.implementation.ResourceUsefulWorkStats;
 import simulator.stats.implementation.TaskStats;
 
@@ -48,5 +52,4 @@
 						buffer.append(fieldSeparator);
 					}
-					
 				}
 
@@ -108,5 +111,11 @@
 					.longValue());
 			buffer.append(fieldSeparator);
-			buffer.append(taskStats.getProcessorsName());
+			buffer.append(taskStats.getHostName());
+			buffer.append(fieldSeparator);
+			buffer.append(taskStats.getProcessingElementsName());
+			buffer.append(fieldSeparator);
+			buffer.append(0);
+			buffer.append(fieldSeparator);
+			buffer.append(taskStats.getExecName());
 			buffer.append(fieldSeparator);
 		}
@@ -311,8 +320,4 @@
 		}
 		
-		int lastIdx = buffer.lastIndexOf(System.getProperty("line.separator"));
-		if(lastIdx != -1)
-			buffer.deleteCharAt(lastIdx);
-		
 		if(resourceUsage.size() > 0){
 			buffer.append("mean: " + resourceUsageStats.getMeanValue());
@@ -373,9 +378,5 @@
 
 		}
-		
-		int lastIdx = buffer.lastIndexOf(System.getProperty("line.separator"));
-		if(lastIdx != -1)
-			buffer.deleteCharAt(lastIdx);
-		
+
 		if(resourceEnergy.size() > 0) {
 			buffer.append("mean: "+resourceEnergyStats.getMeanValue() + " sum: " +resourceEnergyStats.getSumValue());
@@ -437,8 +438,5 @@
 
 		}
-		int lastIdx = buffer.lastIndexOf(System.getProperty("line.separator"));
-		if(lastIdx != -1)
-			buffer.deleteCharAt(lastIdx);
-		
+
 		if(resourceAirFlow.size() > 0) {
 			buffer.append("mean: "+resourceAirFlowStats.getMeanValue());
@@ -500,9 +498,5 @@
 
 		}
-		
-		int lastIdx = buffer.lastIndexOf(System.getProperty("line.separator"));
-		if(lastIdx != -1)
-			buffer.deleteCharAt(lastIdx);
-		
+
 		if(resourceTemperature.size() > 0) {
 			buffer.append("mean: "+resourceTemperatureStats.getMeanValue());
@@ -573,3 +567,24 @@
 	}
 
+	public Object visit(MetricsStats metricsStats) {
+		StringBuffer buffer = new StringBuffer(300);
+		return buffer.toString();
+	}
+
+	public Object visit(ResourceHistoryStats arg) {
+		StringBuffer buffer = new StringBuffer(300);
+		return buffer.toString();
+	}
+
+	public Object visit(ResourceUsefulWorkStats arg) {
+		StringBuffer buffer = new StringBuffer(300);
+		return buffer.toString();
+	}
+
+	public Object visit(ResourceAvailabilityStats arg) {
+		StringBuffer buffer = new StringBuffer(300);
+		return buffer.toString();
+	}
+
+
 }
Index: DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceHistoryStats.java
===================================================================
--- DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceHistoryStats.java	(revision 1207)
+++ DCWoRMS/branches/coolemall/src/simulator/stats/implementation/ResourceHistoryStats.java	(revision 1207)
@@ -0,0 +1,32 @@
+package simulator.stats.implementation;
+
+import java.util.List;
+
+import schedframe.resources.ResourceHistoryChanges;
+import simulator.stats.implementation.out.StatsSerializer;
+
+public class ResourceHistoryStats implements StatsInterface {
+
+	private String[] headers = {"timestamp", "resourceName", "operation", "parameter" };
+
+	protected List<ResourceHistoryChanges> resHistChanges;
+	
+	public ResourceHistoryStats(List<ResourceHistoryChanges> resHistChanges) {
+		super();
+		this.resHistChanges = resHistChanges;
+	}
+
+
+	public Object serialize(StatsSerializer serializer) {
+		return serializer.visit(this);
+	}
+
+	public String[] getHeaders() {
+		return headers;
+	}
+
+
+	public List<ResourceHistoryChanges> getResHistChanges() {
+		return resHistChanges;
+	}
+}
